go的异常处理机制

Dr_Zhang · · 1469 次点击 · · 开始浏览    
这是一个创建于 的文章,其中的信息可能已经有所发展或是发生改变。

在java或php等很多面向对象的语言中, 异常处理是依靠throw、catch来进行的。在go语言中,panic和recover函数在作用层面分别对等throw和catch语句,当然也存在不同之处。

从设计层面来看,panic和recover函数适用于那些真正的异常(例如整数除0),而throw catch finally机制常常被用来处理一些业务层面的自定义异常。因此在go语言中,panic和recover要慎用。

上述两种异常机制的使用中,在处理异常时控制流程的走向也是相似的。

下面将分别举例说明:

try catch finally机制

    try{
        throw new Exception();
    } catch(Exception $e) {
        do something ...
    } finally {
       
    }
       

这种机制中,我们把可能抛出异常的语句或抛出自定义异常的语句放置到try语句块中,而在catch块中,我们将上述语句抛出的异常捕获,针对不同的异常进行报警或log等处理。之后,控制流程进入到finally语句块中。若没有finally语句,控制流程将进入到catch之后的语句中。也就是说,在这种机制中,控制流程是转移到同一层级中异常捕获之后的语句中。

panic recover defer机制

在go的异常机制中,panic可以将原有的控制流程中断,进入到一个"恐慌"流程。这种恐慌流程可以显式调用panic()函数产生或者由运行时错误产生(例如访问越界的数组下标)。panic会在调用它的函数中向本层和它的所有上层逐级抛出,若一直没有recover将其捕获,程序退出后会产生crash;若在某层defer语句中被recover捕获,控制流程将进入到recover之后的语句中。

    /* example 1 */
    package main
    import (
        "fmt"
    )

    func f() {
        defer func() {
            fmt.Println("b")
            if err := recover();err != nil {
                fmt.Println(err)
            }
            fmt.Println("d")
        }()
        fmt.Println("a")
        panic("a bug occur")
        fmt.Println("c")
    }

    func main() {
        f()
        fmt.Println("x")
    }
    

在上述举例中,输出结果为:

    a
    b
    a bug occur
    d
    x
        

这说明,在f函数中抛出的panic被自己defer语句中的recover捕获,然后控制流程进入到recover之后的语句中,即打印d、打印x,之后进程正常退出。

    /* example 2 */
    package main
    import (
        "fmt"
    )

    func g() {
        defer func() {
            fmt.Println("b")
            if err := recover();err != nil {
                fmt.Println(err)
            }
            fmt.Println("d")
        }()
        f()
        fmt.Println("e")
    }

    func f() {
        fmt.Println("a")
        panic("a bug occur")
        fmt.Println("c")
    }

    func main() {
        g()
        fmt.Println("x")
    }
    

上述案例的输出结果是:

    a
    b
    a bug occur
    d
    x

进程经历了这样一个过程:f()中抛出panic,由于自身没有定义defer语句,panic被抛到g()中。g()的defer语句中定义了recover,捕获panic后并执行完defer剩余的语句,之后控制流程被转交到main()函数中,直至进程结束。


有疑问加站长微信联系(非本文作者)

本文来自:Segmentfault

感谢作者:Dr_Zhang

查看原文:go的异常处理机制

入群交流(和以上内容无关):加入Go大咖交流群,或添加微信:liuxiaoyan-s 备注:入群;或加QQ群:1006366459

1469 次点击  
加入收藏 微博
暂无回复
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传